# This holds variables that need to be rollback-proof for whatever reason.

# Set to True when those engine hooks that have to be initialized after the
# UI is started have been applied.

titlereadout_state = None # Animate the title readout?
last_save_caption = ''

renderer_changed = False # Set to True when you change the renderer on the
                        # video prefs screen.

USE_PICKLE_LOAD = False # XXX For testing - we currently can use either pickle
                        # or nopickle load.

# Default value to prevent rollback+autoplay from crashing interestingly.
# XXX actually should init autoplay properly after load.
slideoff_dur = .01
slow_in_progress = False
slow_done_time = 0 # To prevent autoplay+fastforward from crashing.

hovered_save_slot = None

# These are used to keep track of what versions of the game a given save
# comes from.
save_started_in_version = None
save_played_in_versions = None

# fp_adj holds the adjustment used on the load and save scrollbars.
fp_adj = None

#quantized_bar_hooks = dict()
#quantized_bar_adjustments = dict()
#quantized_bars = dict()

surfcache = dict()

flaredata = None

blit_all_cache = dict()

screenshot_surf = None

video_error = None

def clean_caches():
    surfcache.clear()
    global flaredata
    flaredata = None
    global screenshot_surf
    screenshot_surf = None

bench_cache = dict()

import time
def startbench(note):
    global last_bench
    last_bench = [(note,time.time())]
    if note not in bench_cache:
        bench_cache[note] = [last_bench]
    else:
        bench_cache[note].append(last_bench)
        if len(bench_cache[note])>100:
            bench_cache[note] = bench_cache[note][-100:]

def bench(note):
    last_bench.append((note, time.time()))

def checkbench(last_bench):
    longestdur = -1
    prev = last_bench[0][1]
    for n,d in last_bench[1:]:
        dur = d-prev
        if dur>longestdur:
            longestdur = dur
            longest = n
        prev = d
    return last_bench,'longest',longest,longestdur,'total',last_bench[-1][1]-last_bench[0][1]

def checkbenches():
    gtot = 0.
    cache = bench_cache[last_bench[0][0]]
    for cached in cache:
        b = checkbench(cached)
        gtot += b[-1]
    return len(cache),'tries at',gtot,'secs;',gtot/len(cache),'each; last was',b
